package com.shr.utils;

import java.sql.*;


/**
 * 直接访问数据库
 * @author Administrator
 *
 */
public class DBHelper {

	private static DBHelper dbHelper=null;
	private String jdbcConnectionStr;
	private Connection connection;
	private DataSource dataSource = new DataSource();
	private PreparedStatement preparedStatement;
	private ResultSet resultSet;
	
	private DBHelper() {
		jdbcConnectionStr = dataSource.url;	
	}
	
	public static DBHelper createDBHelper() {
	
		dbHelper = new DBHelper();
		dbHelper.initDB();
		return dbHelper;
	}
	
	public void getConn() {
	
		try {
			connection = DriverManager.getConnection(jdbcConnectionStr, dataSource.username, dataSource.password);
			connection.setAutoCommit(false);
		} catch (SQLException e) {
			e.printStackTrace();
		}
	
	}
	
	public void close() {
	
		if (resultSet != null) {
			try {
				resultSet.close();
				if (preparedStatement != null) {
					preparedStatement.close();
				}
				if (connection != null) {
					connection.close();
				}
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
	
	}
	
	public ResultSet executeQuery(String sql, Object[] params) {
		dbHelper.setPrepareStatementParams(sql, params);
		try {
			resultSet = preparedStatement.executeQuery();
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return resultSet;
	}
	
	public Boolean executeUpdate(String sql, Object[] params) {
	
		boolean result = false;
		dbHelper.setPrepareStatementParams(sql, params);
		try {
			if (preparedStatement.executeUpdate() > 0) {
				dbHelper.commit();
				result = true;
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
		return result;
	
	}
	
	@SuppressWarnings("unused")
	private void setPrepareStatementParams(String sql, Object[] params) {
	
		try {
			preparedStatement = connection.prepareStatement(sql);
			if (params != null) {
				for (int i = 0; i < params.length; i++) {
					preparedStatement.setObject((i + 1), params[i]);
				}
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
	
	}
	
	private void initDB() {
		try {
			Class.forName(dataSource.driverclassname);
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
	}
	
	private void commit() {
	
		try {
			connection.commit();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
}